﻿// www.d54x.ru 
// Programs Qt6.1.2 C++  prog3_07
// Bezpodnykh I.P.  
////////////////////////////////////////


#include <QCoreApplication>  // консольное окно

#include <QTextStream>   // для раб. с текстом
#include <conio.h>       // kbhit,   getch
#include <stdio.h>       // fopen,   printf 
#include <qmath.h>       // pow,     sqrt 
#include<iostream>       // cout,    cin
#include <string>        // string
#include <locale>        // setlocale
#include <windows.h>


 
//  наследование и виртуальные функции

 
 using namespace std;        // Пространство имен


class Base 
	{ 
     public:
            Base(){cout <<"Base::Constructor    \n";}
           ~Base(){cout <<"Base::Destructor     \n";}


	         void Show1(){cout <<" Base::Show1()     \n";}
	 virtual void Show2(){cout <<" Virtual Base::Show2() \n";}
     virtual void Show3()=0; // чисто виртуальная функция
             void Show4(){cout <<" Base::Show4()     \n";}
             void Show5(){cout <<" Base::Show5()     \n";}

	};


class Derived1: public Base
	{ 
      public: 
          void Show1(){cout <<"Derived1::Show1()\n";}
          void Show2(){cout <<"Derived1::Show2()\n";}
		  void Show3(){cout <<"Derived1::Show3()\n";}
          void Show4(){cout <<"Derived1::Show4()     \n";}
          void Show5(){cout <<"Derived1::Show5()     \n";}


          Derived1()   {cout <<"Derived1::Constructor()\n";}
         ~Derived1()   {cout <<"Derived1::Destructor()\n";}
	};

class Derived2: public Base
	{ 
      public: 
          void Show1(){cout <<"Derived2::Show1()\n";}
          void Show2(){cout <<"Derived2::Show2()\n";}
		  void Show3(){cout <<"Derived2::Show3()\n";}
          void Show4(){cout <<"Derived2::Show4()     \n";}
          void Show5(){cout <<"Derived2::Show5()     \n";}


          Derived2()   {cout <<"Derived2::Constructor()\n";}
         ~Derived2()   {cout <<"Derived2::Destructor()\n";}
	};
   
int main(int argc, char *argv[])
{


   
 Base *pBase1= (Base *) new Derived1();

 pBase1->Show1();
 pBase1->Show2();
 pBase1->Show3();
 pBase1->Show4();
 pBase1->Show5();
 pBase1->Base::Show2();

 cout<<"\n\n\n";

 Base *pBase2= (Base *) new Derived2();

 pBase2->Show1();
 pBase2->Show2();
 pBase2->Show3();
 pBase2->Show4();
 pBase2->Show5();
 pBase2->Base::Show2();


 //  Ждем нажатия любой клавиши
     while(!kbhit());

 return 0;  // значение, возвращаемое функцией main()  

}
